package com.zanxiang.manage.service.Impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zanxiang.common.utils.bean.BeanUtils;
import com.zanxiang.manage.domain.vo.PayWayChoiceVO;
import com.zanxiang.manage.domain.vo.PayWayVO;
import com.zanxiang.manage.service.PayWayService;
import com.zanxiang.mybatis.entity.PayWay;
import com.zanxiang.mybatis.mapper.PayWayMapper;
import org.springframework.stereotype.Service;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * 支付方式 服务实现类
 *
 * @author xufeng
 * @date 2022-06-17 16:05
 */
@Service
public class PayWayServiceImpl extends ServiceImpl<PayWayMapper, PayWay> implements PayWayService {

    /**
     * 支付方式选择列表查询
     *
     * @return : 返回支付方式列表
     */
    @Override
    public List<PayWayChoiceVO> payWayChoiceList() {
        List<PayWay> payWayList = super.list(new LambdaQueryWrapper<PayWay>().
                select(PayWay::getId, PayWay::getPayName));
        return BeanUtils.copyList(payWayList, PayWayChoiceVO.class);
    }


    /**
     * 支付方式图
     *
     * @return {@link Map}<{@link Long}, {@link PayWayVO}>
     */
    @Override
    public Map<Long, PayWayVO> payWayMap() {
        //查询
        List<PayWay> payWayList = super.list();
        if (CollectionUtils.isEmpty(payWayList)) {
            return Collections.emptyMap();
        }
        List<PayWayVO> list = BeanUtils.copyList(payWayList, PayWayVO.class);
        //构造返回
        return list.stream().collect(Collectors.toMap(PayWayVO::getId, Function.identity()));
    }
}
